package com.four.system.controller;

import com.aliyun.facebody20191230.Client;
import com.aliyun.facebody20191230.models.SearchFaceAdvanceRequest;
import com.aliyun.facebody20191230.models.SearchFaceResponse;
import com.aliyun.tea.TeaException;
import com.aliyun.tea.TeaModel;
import com.aliyun.teautil.Common;
import com.aliyun.teautil.models.RuntimeOptions;
import org.springframework.context.annotation.Configuration;

import java.io.InputStream;
import java.net.URL;

/**
 * @author : tangzhaozhen
 * @createTime : 2023/10/26 23:51
 */
@Configuration
public class SampleTest {

        public static com.aliyun.facebody20191230.Client createClient(String accessKeyId, String accessKeySecret) throws Exception {
        /*
          初始化配置对象com.aliyun.teaopenapi.models.Config
          Config对象存放 AccessKeyId、AccessKeySecret、endpoint等配置
         */
            com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config()
                    .setAccessKeyId("LTAI5tENBECpxHRiWzidh93H")
                    .setAccessKeySecret("MYHeKEYHsAZ1hDGDEKChnFNrglgJ24");
            // 访问的域名
            config.endpoint = "facebody.cn-shanghai.aliyuncs.com";
            return new com.aliyun.facebody20191230.Client(config);
        }

        public static String getFaceLanding(String images) throws Exception {
            // 创建AccessKey ID和AccessKey Secret，请参考https://help.aliyun.com/document_detail/175144.html
            // 如果您使用的是RAM用户的AccessKey，还需要为子账号授予权限AliyunVIAPIFullAccess，请参考https://help.aliyun.com/document_detail/145025.html
            // 从环境变量读取配置的AccessKey ID和AccessKey Secret。运行代码示例前必须先配置环境变量。
            String accessKeyId = "LTAI5tENBECpxHRiWzidh93H";
            String accessKeySecret = "MYHeKEYHsAZ1hDGDEKChnFNrglgJ24";
            Client client = SampleTest.createClient(accessKeyId, accessKeySecret);
////             场景一，使用本地文件
//             InputStream inputStream = new FileInputStream(new File("C:\\Users\\a2075\\Desktop\\SearchFace1.png"));
//            // 场景二，使用任意可访问的url
            URL url = new URL(images);
            InputStream inputStream = url.openConnection().getInputStream();
            SearchFaceAdvanceRequest searchFaceAdvanceRequest = new SearchFaceAdvanceRequest()
                    .setDbName("four_aliyun")
                    .setLimit(1)
                    .setImageUrlObject(inputStream);
            RuntimeOptions runtime = new RuntimeOptions();
            try {
                // 复制代码运行请自行打印 API 的返回值
                SearchFaceResponse searchFaceResponse = client.searchFaceAdvance(searchFaceAdvanceRequest, runtime);
                // 获取整体结果
                System.out.println(Common.toJSONString(TeaModel.buildMap(searchFaceResponse)));

                // 获取单个字段：Confidence转换后的置信度
                Float confidence = searchFaceResponse.getBody().getData().getMatchList().iterator().next().getFaceItems().iterator().next().getConfidence();
                System.out.println("对比度为："+confidence);
                if (confidence > 75){
                    String entityId = searchFaceResponse.getBody().getData().getMatchList().iterator().next().getFaceItems().iterator().next().getEntityId();
                    System.out.println("confidence对比值为："+confidence);
                    System.out.println("entityId为："+entityId);
                    return entityId+"@qq.com";
                }


            } catch (TeaException teaException) {
                // 获取整体报错信息
                System.out.println(com.aliyun.teautil.Common.toJSONString(teaException));
                // 获取单个字段
                System.out.println(teaException.getCode());
                return "500";
            }
            return "请先去录制人脸";
        }

}
